// ClientDisplay.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "Utpapi.h"

#define MAX_LOADSTRING 100
#define MAX_DEVICE_NAME      20


// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text
BOOL  fExit; // exit thread flag
HANDLE hController=INVALID_HANDLE_VALUE; // the second display controller handler
HANDLE hExitEvent=INVALID_HANDLE_VALUE; // inform exit thread event
RECT sArea; //store the second display area
BYTE   curByte;
UCHAR  rawData[5];
VOID  ReportCoord(HWND hWnd, UCHAR  *Data);
BYTE   haveDown;
LONG  OldXY[2];


// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
ULONG CALLBACK      RunThreadFunction(PVOID pv);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
	BYTE   tcNum, tcIdx;
	CHAR  DeviceName[MAX_DEVICE_NAME];

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CLIENTDISPLAY, szWindowClass, MAX_LOADSTRING);
	fExit=FALSE;
	curByte=0;
	haveDown=0;
	hExitEvent=CreateEvent(NULL, TRUE, FALSE, NULL);

	//Find the controller is the second display.
	tcNum = GetExistControllers();

	if (tcNum == 0) return -1;
    else{
	  for (tcIdx=0; tcIdx<tcNum; tcIdx++)
	  {
		   GetControllerName((BYTE)(tcIdx+1), DeviceName, MAX_DEVICE_NAME);
		   hController=OpenController(DeviceName);
  
           if (hController==INVALID_HANDLE_VALUE) continue;
		   else{
			   BYTE   displayNum;
			   displayNum = GetDisplayNumber(hController);
			   if (displayNum==1) break; //have found the second display
			   CloseController(hController);
		   }
	  }

	  if (tcIdx==tcNum) return -1; //Can't find the second display controller.
	}


	MyRegisterClass(hInstance);
	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) return FALSE;

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CLIENTDISPLAY);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_CLIENTDISPLAY);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
   BYTE  displayNum=0;
   CHAR devName[60];

   hInst = hInstance; // Store instance handle in our global variable
   
   //Get Display Number
   displayNum=GetExistDisplays();

   if (displayNum<2) return FALSE;
	  
   GetDisplayName(2, devName, (BYTE)sizeof(devName)); //2-->Display 2
   GetDisplayArea(devName, &sArea);

   DisableTouchReport(hController, 1);

   hWnd = CreateWindow(szWindowClass, szTitle, WS_POPUP ,
      sArea.left, sArea.top, sArea.right-sArea.left, sArea.bottom-sArea.top, 
	  NULL, NULL, hInstance, NULL);

   if (!hWnd) return FALSE;

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	DWORD           runthreadID;
    HANDLE          hRunThread;

	switch (message) 
	{
	    case WM_CREATE:
			{
			  HWND   hwndBtnFun2;
			  char   szString[20];

			  LoadString (hInst, IDM_FUNC2, szString, sizeof(szString));
	          hwndBtnFun2 = CreateWindow ("BUTTON", szString,
		                                WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE,
		                                0, 0, 0, 0,
		                                hWnd, (HMENU)IDM_FUNC2, hInst, NULL);

			  SetWindowPos (hwndBtnFun2, NULL, (sArea.right-sArea.left)/2, (sArea.bottom-sArea.top)-30, 50, 20,
		                    SWP_NOZORDER | SWP_NOACTIVATE);
              //Create a thread to poll data
			  hRunThread = CreateThread( NULL, 0, (LPTHREAD_START_ROUTINE) RunThreadFunction, 
                                         hWnd, 0, &runthreadID);
			
			}
            break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_FUNC2:
			        DestroyWindow(hWnd);
		            break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			DisableTouchReport(hController, 0);
			fExit=TRUE;
			WaitForSingleObject( hExitEvent, INFINITE);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


ULONG CALLBACK RunThreadFunction(PVOID pv)
{
	DWORD i, nBytes;
	UCHAR RespBuf[255];
	HWND   hWnd;

	hWnd = (HWND)pv;

	while (fExit==FALSE) {
		memset(RespBuf, 0, sizeof(RespBuf));
		if (hController != INVALID_HANDLE_VALUE)
		   nBytes = ReadBuffer(hController, RespBuf, 255);

		for (i=0; i<nBytes; i++) {
			rawData[curByte]=RespBuf[i];   
            switch ( curByte ) {
                    case 0: 
						if ( (rawData[0] & 0x80) != 0) { //Enter Mouse data packet
                           curByte++; //Enter Data Packet
						}
                        break;
                    case 1:
                        if ( (rawData[1] & 0x80) == 0 ) curByte++;
                        else {
						    rawData[0]= rawData[1];
							curByte = 1;
						}
                        break;
                    case 2:
                        if ( (rawData[2] & 0x80) == 0 ) curByte++;
                        else {
						    rawData[0]= rawData[2];
							curByte = 1;
						}
                        break;
                    case 3:
                        if ( (rawData[3] & 0x80) == 0 ) curByte++;
                        else {
						    rawData[0]= rawData[3];
							curByte = 1;
						}
                        break;
                   case 4:
                        if ( (rawData[4] & 0x80) == 0 ) {                             
							ReportCoord(hWnd, rawData);
						    curByte = 0;
                        }     
						else {
						    rawData[0]= rawData[4];
							curByte = 1;
						}
                        break;
				}
		}

	}
	SetEvent(hExitEvent);

	return 1;
}


VOID  ReportCoord(HWND hWnd, UCHAR  *Data)
{
	LONG  CXY[2];
	POINT PrePoint;
	HPEN  hNewPen, hOldPen;
	HDC   hdc;

    hdc = GetDC( hWnd );

	hNewPen = CreatePen( PS_SOLID, 2, RGB(255, 0, 0)); //red color
	hOldPen = (HPEN)SelectObject (hdc, hNewPen);

	CXY[0]  = ((LONG)Data[1]) + (((LONG)Data[2])<<7); //X
    CXY[1] = ((LONG)Data[3]) + (((LONG)Data[4])<<7); //Y

    CXY[0] = CXY[0]*(sArea.right-sArea.left)/16384;
	CXY[1] = CXY[1]*(sArea.bottom-sArea.top)/16384;

	if (Data[0]&0x40){//pen down flag
		if (haveDown==0) {
            MoveToEx(hdc, CXY[0], CXY[1], &PrePoint);
			OldXY[0]=CXY[0];
			OldXY[1]=CXY[1];
			haveDown=1;
		}
		else{
			MoveToEx(hdc, OldXY[0], OldXY[1], &PrePoint);
            LineTo( hdc, CXY[0], CXY[1]);
			OldXY[0]=CXY[0];
			OldXY[1]=CXY[1];

		}
	}
	else{//pen up
		haveDown=0;
		MoveToEx(hdc, OldXY[0], OldXY[1], &PrePoint);
		LineTo( hdc, CXY[0], CXY[1]);
	}


	SelectObject (hdc, hOldPen);
	DeleteObject (hNewPen);
	ReleaseDC( hWnd, hdc );

}